# =============================================================================
# Mars Build Specification
#
# =============================================================================

env:
  LDFLAGS: >-
    -X
    gitlab.com/mergetb/facility/mars/pkg.Version=`
    git describe --always --long --dirty`
  GOOS: linux
  GOARCH: arm

# Services ....................................................................

canopy:
  out:
    - build/canopy.arm5
    - build/canopy.arm7
  in:
    - service/canopy/apiserver.go
    - service/canopy/handlers.go
    - service/canopy/main.go
    - service/canopy/reconciler.go
    - service/canopy/util.go
    - service/canopy/vtysh.go
    - service/canopy/types.go
    - reconcile_lib
  env:
    CGO_ENABLED: 0
  build:
    - GOARM=5 go build -o $out[0] $in[0:6]
    - GOARM=7 go build -o $out[1] $in[0:6]

dance:
  out:
    - build/dance.arm5
    - build/dance.arm7
  in:
    - service/dance/main.go
    - service/dance/reconciler.go
    - service/dance/server.go
    - coredance
    - storage_lib
    - dance_lib
  env:
    CGO_ENABLED: 0
  build:
    - GOARM=5 go build -ldflags="$LDFLAGS" -o $out[0] $in[0:2]
    - GOARM=7 go build -ldflags="$LDFLAGS" -o $out[1] $in[0:2]

coredance:
  in:
    - service/dance/coredance/dance.go
    - service/dance/coredance/setup.go

# Libraries ...................................................................

storage_lib:
  in:
    - internal/storage/materialize.go
    - internal/storage/etcd.go
    - internal/storage/minio.go
    - internal/storage/state.go
    - internal/storage/sled.go
    - internal/storage/keys.go
    - internal/storage/model.go
    - internal/storage/wireguard.go
    - internal/storage/config.go

reconcile_lib:
  in:
    - internal/reconcile/keys.go

dance_lib:
  in:
    - pkg/dance/cache.go
    - pkg/dance/server.go
    - pkg/dance/dhcp.go
    - pkg/dance/dns.go
    - pkg/dance/util.go
